// Bambino
// TAB FILE > movement20.ino

//     META MOVEMENT - turnAway(), turnMemory(), turnOther() 
//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(), 
//                rollCentre(), rollRight(), rollLeft(), 
//                paceCentre(), paceRightForward(), paceLeftForward(), paceRightBackward(), paceLeftBackward(), 
//                rollmove(), pacemove()

//== META MOVEMENT ==========================================
void turnAway()    // turn away from the leading foot, so if the right foot is in front then turn left
{ if (paceat < paceC)          // ie right foot forward    
  {turnLeft();}  else {turnRight();}
}
//----------------------------
void turnMemory()  // turn the same way as last time
{ if (f_TurnedRight) {turnRight();}  else {turnLeft();} }
//----------------------------
void turnOther()   // turn the opposite way from last time
{ if (f_TurnedRight) {turnLeft();}  else {turnRight();} }

//== MOVEMENT ===============================================
void forward()       // Walk one step forwards
{ f_forwards =1;
  if (paceat<paceC)
    { rollRight();  paceLeftForward();  rollCentre(); } 
    else
    { rollLeft();  paceRightForward();  rollCentre(); } 
} 
//----------------------------
void backward()       // Walk one step backwards
{ f_forwards =0;
  if (paceat>paceC)
    { rollRight();  paceLeftBackward();  rollCentre(); } 
    else
    { rollLeft();  paceRightBackward();  rollCentre(); } 
} 
//----------------------------
void turnRight()
{ // Turn right.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  if (paceat > paceC)          // ie left foot forward       
  { paceRightForward(); }
  else
  { if (f_forwards) { forward(); } else { backward(); }
    paceRightForward();
  }
  f_TurnedRight =1;
}  
//----------------------------
void turnLeft()
{ // Turn left.
  // Bambino turns by sliding its feet in a 'tank' or 'skid' turn.
  // to turn right, the left foot must be forward. 
  // If it isn't then a step has to be made.
  if (paceat < paceC)          // ie right foot forward      
  { paceLeftForward(); }
  else
  { if (f_forwards) { forward(); } else { backward(); }
    paceLeftForward();
  }
  f_TurnedRight =0;  
}  
//----------------------------
void rollCentre()        { rollto =rollC;          rollmove(); }
void rollRight()         { rollto =rollC +rollby;  rollmove(); }
void rollLeft()          { rollto =rollC -rollby;  rollmove(); }
void paceCentre()        { paceto =paceC;          pacemove(); }
void paceRightForward()  { paceto =paceC -paceby;  pacemove(); }
void paceLeftForward()   { paceto =paceC +paceby;  pacemove(); }
void paceRightBackward() { paceLeftForward(); }
void paceLeftBackward()  { paceRightForward(); }
//----------------------------
void rollmove()    // do roll move  
{
  if (rollspeed==0) {rollspeed =1;}     // dont hang if 0
  if (rollto > rollat)
    { for (rollat =rollat; rollat <rollto; rollat +=rollspeed)  {ServoPulse(servoRollPin,rollat); delay(Servoframe);} }  
     else     
    { for (rollat =rollat; rollat >rollto; rollat -=rollspeed)  {ServoPulse(servoRollPin,rollat); delay(Servoframe); } }
  rollat =rollto; ServoPulse(servoRollPin,rollat); delay(Servoframe);      // make sure servo is at rollto for speed >1
}
//----------------------------
void pacemove()    // do pace move
  { if (pacespeed==0) {pacespeed =1;}     // dont hang if 0 
    if (paceto > paceat)
      { for (paceat =paceat; paceat <paceto; paceat +=pacespeed)  {ServoPulse(servoPacePin,paceat); delay(Servoframe); } }  
     else     
      { for (paceat =paceat; paceat >paceto; paceat -=pacespeed)  {ServoPulse(servoPacePin,paceat); delay(Servoframe); } }
    paceat =paceto; ServoPulse(servoPacePin,paceat); delay(Servoframe);    // make sure servo is at paceto for speed >1
  }
//===========================================================

