//B_PM34_vbt.ino

char thisrobot[] ="BambinoPM ";
char thisprog[]  ="B_PM34_vbt";
// Binary sketch size:  13,720 bytes (of a 30,720 byte maximum)

/*
Introducing
'v', 'b','e','o' choose sound: 'b' bip, 'e' whee, 'o' whoa
'b', 'p','1'-'9'  set behave paceby - step length
     't','1'-'9'  set behave turnby - step length in turns
     'r','1'-'9'  set behave rollby - roll amount when stepping    
A new Tab file skills34.ino for 
't', 'a' - turn Away from leading foot, 
     'm' - turn Memory (same way as last turn,
     'o' - turn Other way from last time
     these will be used in avoid Acts
------------------------------------------
Note - The Arduino Serial Monitor can't send [Esc]. 
       If another Terminal is used which can send [Esc] then at GetCcmnd() this will be printed,
	   which may print as a symbol or the Terminal may change it to "."

improvements? - 
void GetCcmnd()	  could use   case 0:   
     
Bugs -	   
GetAct should use GetCcmnd to read Act from current act rather than a prompt. rx,px,lx,cx would then be playable

To do next - 
pm - Print Mind - EEPROM values (255 - 247)
   - f_walking, rollC, paceC, rollby, paceby, rollmin, rollmax, pacemin, pacemax
lm - Load Mind  - EEPROM values (255 - down)
   - byte values - how to load byte values?
b(1-9) - behaviour set - same format as Acts +current behaviour rules in page2 
------------------------------------------
   
The commands are 
'.',[Esc] - quit current operation - recording, playing, input
'S' - Stop/Start
'P' - Print moves in all Acts, and behaviour variables
'D' - Dump out all acts to the PC, same as 'P' but without the Act and moves numbers
'1'-'8' the routine or Act to record or replay
'F' - Forwards one step
'B' - Backwards one step
'R' - turn Right one step
'L' - turn Left one step
'H' - Halt with both feet together
'V' - Voice, make a beep, whee
'U' - read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
'W' - read Whisker sensors and avoid holes (if any) using avoidObstacles() behaviour rules
'G' - read Beard sensors and avoid obstacles (if any) using avoidHoles() behaviour rules
'A' - beAlive()  until '.' or Esc or reset      // the loop() from B_PM22_BeAlive
'X' - Xplore()   until '.' or Esc or reset      // Wander()
'E' - Experiment - user routine  until '.' or Esc or reset
'v','b','e','o' choose sound: 'b' bip, 'e' whee, 'o' whoa
'w','1'-'9' - wait 1 - 9 seconds 
'su' - speedup, speed is increased by 1 up to max
'sd' - speed down, speed is divided by 2 down to 1
's','1'-'9' set speed, both roll and pace speeds set to the same
'sr','1'-'9' set roll speed                              units of servo degrees change per frame
'sp','1'-'9' set pace speed                              units of servo degrees change per frame
'sm' - set rollspeedmax to current rollspeed, set pacespeedmax to current pacespeed
'srm' - set rollspeedmax to current rollspeed
'spm' - set pacespeedmax to current pacespeed
'b','p','1'-'9'  set behave paceby - step length - units of 2 servo degrees
    't','1'-'9'  set behave turnby - step length in turns - units of 2 servo degrees
    'r','1'-'9'  set behave rollby - roll amount when stepping - units of 2 servo degrees
't','a' - turn Away from leading foot, will be used in avoid Acts
    'm' - turn Memory (same way as last turn, will be used in avoid Acts
    'o' - turn Other way from last time, will be used in avoid Acts 
'r','1'-'8' - Record moves into selected Act in EEPROM
'p','1'-'8' - Print moves in selected Act '1' - '8'
'c','1'-'8','1'-'8' -  copy one Act to another Act slot
'l','1'-'8' - load Act, like 'r' but records commands into EEPROM without playing them
'?' - print instructions

The whiskerLEDs glowing dim indicate Bambino is ready for a command.
If other keys are pressed, including lower case keys, then the Whisker LEDs will flash badkey().
*/

//== #define ================================================
#define autoAct '8'   //Act '1' - '8' to autorun

//== SECTIONS ===============================================
//== NEW 
//== CHANGED
//== INCLUDES
//     pinsPM20.h     - pin usage
//     varsConsPM34.h - EEPROM addresses, general, Ultrasonic module HC-SR04
//     EEPROM.h     - the Arduino EEPROM library
//     avr/pgmspace.h - to allow the printHelp() text to be in ProgramSpace
//== EEPROM
//== SETUP
//     initPM34.h     - Initialise various things
//== LOOP
//== FUNCTIONS
//   GetCcmnd()	       //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
//   RecordCCmnd()	
//   makeCcmndDigit()  //ensure 1-9
//   waitCcmndSecs()   //read delay time from Act and wait
//   DumpActs()        //Dump Acts, Print without names and length
//   loadAct()
//   copyAct()
//   Ccmnd <- PlayAct() 
//   PrintAllActs()
//   printAct()
//   Act <- getAct() 
//   setEEPROMindexes(char Act)      //  changes EEPROMindex, ActEnd
//   printHelp()
//   badkey()         // indicate invalid key
//   USreact()        // read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
//   WhiskerReact()   // read Whisker sensors and avoid holes (if any) using avoidObstacles() behaviour rules
//   BeardReact()     // read Beard sensors and avoid obstacles (if any) using avoidHoles() behaviour rules
//   beAlive()        // the loop() from B_M22_BeAlive
//   redLEDon()
//   redLEDoff() 
//   bip()            // make a bip sound
//   whiskerLEDsDim()
//   whiskerLEDsOff()
//TAB FILES
//   actsPM23.ino
//     ACTS - WanderSteps(steps), Wander()
//            RightStep(steps), LeftStep(steps)
//            rock(repeats), shuffle(repeats)
//     SOUND -  whee(), whoa()  
//   behaviourPM20.ino
//     BEHAVIOUR MODIFIERS - speeddown(), speedup()
//     BEHAVIOUR RULES - avoidUObjects(), avoidObstacles(), avoidHoles()
//   sensePM25.ino
//     SENSE - dist_HC_SR04()
//           - readWhiskers(), QueryObstacle(), showWhiskerLightLevels() 
//           - readBeard(), QueryEdge(), showBeardLightLevels() 
//   movement34.ino
//     MOVEMENT - forward(), backward(), turnRight(), turnLeft(), 
//                halt(), 
//                rollCentre(), rollLeft(), rollRight(),
//                paceCentre(), paceLeftForward(),  paceRightForward(), 
//                              paceLeftBackward(), paceRightBackward(), 
//                              turnLeftForward(),  turnRightForward(), 
//                              turnLeftBackward(), turnRightBackward(), 
//                rollmove(), pacemove()
//   skills34.ino 
//     META MOVEMENT - turnAway(), turnMemory(), turnOther() 
//   servos20.ino
//     SERVOS - ServosInitC()
//   hardware20.ino
//     HARDWARE - ServoPulse(byte Spin, int Spulse), beep(byte beeppin,int beepfreqHz,long beeptime)
//   system20.ino
//     SYSTEM - toggle_f_walking(), initialiseEEPROM()

//== NEW ====================================================
/*
varsConsPM34.h  - byte turnby;     // servo turn angles about paceC
                  boolean f_turning =0; // controls pace in paceLeftForward() and paceRightForward() when turning
movement34.ino - turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward() 
skills34.ino - turnAway(), turnMemory(), turnOther()
*/
//== CHANGED ================================================
/*
//== HELP TEXT - amended instructions
void setup() {  #include "initPM33.h" //Initialise various things 
loop() - cases 'v','t','b'
varsConsPM23.h -> varsConsPM34.h  - turnby
void PrintAllActs() - now prints paceby, rollby, turnby  
initPM20.h -> initPM34.h      - initialises turnby 
movement34.ino - turnRight()	  //now uses turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward(), sets f_turning  
movement34.ino - turnLeft()	   	//now uses turnRightForward(), turnLeftForward(), turnRightBackward(), turnLeftBackward(), sets f_turning
movement34.ino - paceLeftForward(), paceRightForward() test f_turning
*/

//== INCLUDES ===============================================
#include "pinsPM20.h"
#include "varsConsPM34.h"
#include <EEPROM.h>           // to read and write internal EEPROM
  // EEPROM.write(address,bytevalue)
  // bytevalue =EEPROM.read(address)
#include <avr/pgmspace.h>     // for the printHelp() text
  
//== VARIABLES and CONSTANTS ================================
boolean f_recording =false;   //recording an Act
boolean f_recordC =false;     //record current Command
boolean f_play =false;        //Play current Act
boolean f_firstRun =true;     //true for the first loop only
const byte NL =10;            //NewLine value
const byte LF =10;            //LineFeed value
const byte CR =13;            //Carriage Return value
const byte Esc =27;           //Esc key value
char Act;                     //current Act as '1' - '8'
byte actIndex =0;             //current Act number, set to default           
int EEPROMindex;              //index to moves in an Act in second page of EEPROM
int ActEnd;                   //end address of current recording Act in EEPROM
int moves =0;                 //current move
char Ccmnd =0;                //current Character command, default null command

//== HELP TEXT ==============================================
// see http://arduino.cc/en/Reference/PROGMEM

char helpbuffer[80];          //buffer for helptext in PROGMEM

const char h_1[] PROGMEM = "'1'-'8' the routine or Act to record or replay";
const char h_Q[] PROGMEM = "'.',[Esc] - quit playing or recording";
const char h_P[] PROGMEM = "'P' - Print moves in all Acts and speed";
const char h_D[] PROGMEM = "'D' - Dump out all acts to the PC"; 
const char h_F[] PROGMEM = "'F' - Forwards one step";
const char h_B[] PROGMEM = "'B' - Backwards one step";
const char h_R[] PROGMEM = "'R' - turn Right one step";
const char h_L[] PROGMEM = "'L' - turn Left one step";
const char h_H[] PROGMEM = "'H' - Halt with both feet together";
const char h_V[] PROGMEM = "'V' - Voice, make a beep";
const char h_S[] PROGMEM = "'S' - Stop/Start toggle reset flag stopped/walking";
const char h_U[] PROGMEM = "'U' - read Ultrasonic sensor and react";
const char h_W[] PROGMEM = "'W' - read Whisker sensors and avoid obstacles";
const char h_G[] PROGMEM = "'G' - read Beard sensors and avoid holes";
const char h_A[] PROGMEM = "'A' - beAlive()   until quit";
const char h_X[] PROGMEM = "'X' - Xplore()   until '.' or reset";
const char h_E[] PROGMEM = "'E' - Experiment - user routine  until '.' or reset";
const char h_v[]   PROGMEM = "'v','b','e','o' - choose sound: 'b' bip, 'e' whee, 'o' whoa";
const char h_w[]   PROGMEM = "'w', '1'-'9' - wait 1 - 9 seconds"; 
const char h_su[]  PROGMEM = "'su' - speedup, speed is increased by 1 up to max"; 
const char h_sd[]  PROGMEM = "'sd' - speed down, speed is divided by 2 down to 1"; 
const char h_s[]   PROGMEM = "'s', '1'-'9' set roll and pace speeds to the same"; 
const char h_sr[]  PROGMEM = "'sr', '1'-'9' set roll speed"; 
const char h_sp[]  PROGMEM = "'sp', '1'-'9' set pace speed"; 
const char h_sm[]  PROGMEM = "'sm' - set rollspeedmax, pacespeedmax to current speeds";
const char h_srm[] PROGMEM = "'srm' - set rollspeedmax to current rollspeed"; 
const char h_spm[] PROGMEM = "'spm' - set pacespeedmax to current pacespeed"; 
const char h_bp[]  PROGMEM = "'b','p','1'-'9'  set behave paceby - step length";
const char h_bt[]  PROGMEM = "    't','1'-'9'  set behave turnby - step length in turns";
const char h_br[]  PROGMEM = "    'r','1'-'9'  set behave rollby - roll amount when stepping";
const char h_ta[]  PROGMEM = "'t','a' - turn Away from leading foot"; 
const char h_tm[]  PROGMEM = "    'm' - turn Memory (same way as last turn";
const char h_to[]  PROGMEM = "    'o' - turn Other way from last time";
const char h_r[]   PROGMEM = "'r','1'-'8' - Record moves into EEPROM";
const char h_p[]   PROGMEM = "'p','1'-'8' - Print moves in selected Act '1' - '8'";
const char h_c[]   PROGMEM = "'c','1'-'8','1'-'8' -  copy one Act to another Act slot";
const char h_l[]   PROGMEM = "'l','1'-'8' - load Act into EEPROM without playing it"; 
const char h_instruct[] PROGMEM = "'?' - these instructions";
  
PROGMEM const char * const help_table[] =
  { h_1,    h_Q,    h_P,    h_D,    h_F,    h_B,    h_R,    h_L,    h_H,
    h_V,    h_S,    h_U,    h_W,    h_G,    h_A,    h_X,    h_E,
    h_v,    h_w,    h_su,   h_sd,   h_s,    h_sr,   h_sp,   h_sm,   h_srm,  h_spm,
    h_bp,   h_bt,   h_br,   h_ta,   h_tm,   h_to,
    h_r,    h_p,    h_c,    h_l,    h_instruct
  };

//== SETUP ==================================================
void setup() 
{ 
  #include "initPM34.h" //Initialise various things
  
  //now configure Bambino
  f_forwards =1;    // set default
  rollspeed =1;     // start off slow
  pacespeed =1;     // start off slow
  rollspeedmax =4;  // quite fast 
  pacespeedmax =6;  // quite fast
  
}
//== LOOP ===================================================
void loop()
{ 
  f_recordC =true;     // record Command, default =true
  whiskerLEDsDim();    //indicate ready for command  
  if(f_recording)  { redLEDon(); } else { redLEDoff(); }
  if(f_play)       { whiskerLEDsOff();  }
  if(!f_play)      { Serial.print(">"); }    //ready prompt
  
  if (!f_firstRun) 
    { GetCcmnd(); }	       //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
    else
    { Ccmnd =autoAct;  f_firstRun =false; }   //done on the first loop only

DoCommand:
  switch (Ccmnd) 
  { case LF:   f_recordC =false;  break;     //linefeed
    case CR:   f_recordC =false;  break;     //carriage return
    case ' ':  break;     //strip space
    case ',':  break;     //strip comma
    case Esc:  Ccmnd ='.';     //[Esc] key, fall through to '.'
    case '.':  if (f_recording) {  EEPROM.write(EEPROMindex,'.'); }     // terminated string
               f_recording =false;
               f_play =false;
               Serial.println();
               break;
    case 'P':  if (!f_recording) { PrintAllActs(); }  break;
    case 'A':	 // if recording record 'A' otherwise do beAlive() until '.' or reset
               if (!f_recording) { beAlive(); }  break;
    case 'X':	 // if recording record 'X' otherwise do Xplore() until '.' or reset
               if (!f_recording) { Xplore(); }  break; 
    case 'E':	 // if recording record 'E' otherwise do Experiment() until '.' or reset
               if (!f_recording) { Experiment(); }  break; 
    case '1':  // fall through
    case '2':  // fall through
    case '3':  // fall through
    case '4':  // fall through
    case '5':  // fall through
    case '6':  // fall through
    case '7':  // fall through
    case '8':  if (!f_recording) { f_play =true; Act =Ccmnd;  setEEPROMindexes(Act); }  break;
    case 'F':  forward();      break;        
    case 'B':  backward();     break;        
    case 'R':  turnRight();    break;        
    case 'L':  turnLeft();     break;        
    case 'H':  halt();         break; 
    case 'V':  whee();         break;   //Spkr and LED on different pins           
    case 'S':  f_recordC =false;
               toggle_f_walking(); 
               if (f_walking) {Serial.println(" walking");} else {Serial.println(" stopped");}
               break;    
    case 'U':  USreact();      break; 
    case 'W':  WhiskerReact(); break; 
    case 'G':  BeardReact();   break;
    case 'v':  if (f_recording) { RecordCcmnd(); }    //so 'v' is recorded
               GetCcmnd();                            //get parameter
               switch (Ccmnd) 
               { case 'b':  bip();   break;
                 case 'e':  whee();  break;
                 case 'o':  whoa();  break;
                 default:   bip();   Ccmnd ='b';  break;
               }    // end switch
               break;                
    case 'w':  if (f_recording) { RecordCcmnd(); }    //so 'w' is recorded
               GetCcmnd();                            //get parameter
               makeCcmndDigit();                      //ensure '1'-'9'
               waitCcmndSecs();
               if (!f_play) { Serial.print(">"); }    //ready prompt
               break;                                 // if recording Ccmnd will be recorded
    case 's':  if (f_recording) { RecordCcmnd(); }    //so 's' is recorded
               GetCcmnd();                            //get parameter
               if (Ccmnd=='u') { speedup();  break; }     // and if recording record 'u' 
               if (Ccmnd=='d') { speeddown();  break; }   // and if recording record 'd' 
               if (Ccmnd=='m') { rollspeedmax =rollspeed; pacespeedmax =pacespeed; break; }
               if (Ccmnd=='r') 
               { if (f_recording) { RecordCcmnd(); }  //so 'r' is recorded
                 GetCcmnd();                          //get parameter
                 if (Ccmnd=='m') { rollspeedmax =rollspeed; break; }
                 //else                 
                 makeCcmndDigit();                    //ensure '1'-'9'    
                 rollspeed =Ccmnd -'0';
                 break;                               // and if recording record digit
               }
               if (Ccmnd=='p') 
               { if (f_recording) { RecordCcmnd(); }  //so 'p' is recorded
                 GetCcmnd();                          //get parameter
                 if (Ccmnd=='m') { pacespeedmax =pacespeed; break; }
                 //else                 
                 makeCcmndDigit();                    //ensure '1'-'9'    
                 pacespeed =Ccmnd -'0';
                 break;                               // and if recording record digit 
               }
               //else                 
               makeCcmndDigit();                      //ensure '1'-'9'    
               rollspeed =max(1,Ccmnd -'0'); 
               pacespeed =max(1,Ccmnd -'0');  break;	// and if recording record digit 
    case 't':  if (f_recording) { RecordCcmnd(); }    //so 't' is recorded
               GetCcmnd();                            //get parameter
               switch (Ccmnd)
               { case 'a':  turnAway();    break;
                 case 'm':  turnMemory();  break;
                 case 'o':  turnOther();   break;
                 default:   turnMemory();   Ccmnd ='m';  break;
               }    // end switch
               break;                               
    case 'b':  if (f_recording) { RecordCcmnd(); }    //so 'b' is recorded
               GetCcmnd();                            //get parameter
               switch (Ccmnd)
               { case 'p':  if (f_recording) { RecordCcmnd(); }    //so 'p' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            paceby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;
                 case 't':  if (f_recording) { RecordCcmnd(); }    //so 't' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            turnby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;
                 case 'r':  if (f_recording) { RecordCcmnd(); }    //so 'r' is recorded
                            GetCcmnd();                            //get parameter
                            makeCcmndDigit();                      //ensure '1'-'9'
                            rollby =(Ccmnd -'0') *2;  //gives a maximum of 18, default 15
                            break;
                 default:   badkey();  Serial.println("bad key");
                            Ccmnd ='?';     //so if recording then '?' is recorded
                            break;          //don't do anything
               }    // end switch
               break;                               
    case 'r':  f_recordC =false;
               redLEDon();
               if (!f_recording) 
                 { getAct();  if(Ccmnd=='.') { break; }  
                   setEEPROMindexes(Act);  f_recording =true; 
                 }
               break;
    case 'p':  f_recordC =false;  
               if (!f_recording) 
                 { getAct();  if(Ccmnd=='.') { break; }  
                   printAct();  break;
                 }
    case 'c':  f_recordC =false;  if (!f_recording) { copyAct(); }  break;	
    case 'l':  f_recordC =false;  if (!f_recording) { loadAct(); }  break;
    case 'D':  f_recordC =false;  if (!f_recording) { DumpActs(); }  break;
    case '?':  f_recordC =false;  printHelp();  break;     // print instructions
    default:   f_recordC =false;  badkey();  Serial.println("bad key");  break;  //don't record bad key		
  }    // end switch
	
Record:	
  if (f_recording  && f_recordC) { RecordCcmnd(); } 
  
}   
//== FUNCTIONS ==============================================

void GetCcmnd()	       //reads Serial or playing Act until Ccmnd != 0, prints Ccmnd
{ Ccmnd =0;
  while(Ccmnd==0)
  { if(f_recording)  
      { while(!Serial.available()) {}           //wait for Serial
        Ccmnd =Serial.read();  bip(); 
      } 
    if(!f_recording) 
      { if(Serial.available()) 
          { Ccmnd =Serial.read(); }             //over-ride if Serial, null ignored  
          else 
          { if(f_play) 
              { Ccmnd =PlayAct();               //get Act Ccmnd 
              }                             
          }
      }//end if(!f_recording)                                               
  }//end while
  Serial.print(Ccmnd);  
}  
//============================  
void RecordCcmnd()	
{ EEPROM.write(EEPROMindex,Ccmnd);
  EEPROMindex++;
  if (EEPROMindex>=ActEnd) { f_recording =false;  EEPROM.write(ActEnd,'.');  badkey(); }     // terminated string 
}  
//============================  

void Experiment()       //until Quit
{ while(true)
  { 
    //put your own routine here e.g.
    rollspeed =4;
    pacespeed =4;
    forward();       // Walk one step forwards
    forward();       // Walk one step forwards
    forward();       // Walk one step forwards
    whee(); 
    turnRight();
    turnRight();
    turnRight();    
    whee(); 
    rollspeed =2;
    pacespeed =2;
    turnLeft();
    turnLeft();
    turnLeft();
    whee(); 
    rollspeed =1;
    pacespeed =1;
    backward();      // Walk one step backwards
    backward();      // Walk one step backwards
    backward();      // Walk one step backwards
    whee();    
    whee();    
    whee();    
    //check for Quit
    if(Serial.available()) { Ccmnd =Serial.read(); if(Ccmnd=='.' || Ccmnd==Esc) { Serial.print(">");  break; } }
  }	// end while
}
//----------------------------
void Xplore()         //Wander() until Quit
{ while(true)
  { Wander();
    //check for Quit
    if(Serial.available()) { Ccmnd =Serial.read(); if(Ccmnd=='.' || Ccmnd==Esc) { Serial.print(">");  break; } }
  }	// end while
}
//----------------------------  
byte makeCcmndDigit()      //ensure 1-9
{ if (Ccmnd<'1' || Ccmnd>'9') { Ccmnd ='1'; } //default
}
//----------------------------  
void waitCcmndSecs()   //read delay time from Act and wait
{ if (Ccmnd<'1' || Ccmnd>'9') { Ccmnd ='1'; } //default
  byte cmnd =Ccmnd -'0';                          // ASCII to numeric
  delay(cmnd *1000);
}  
//----------------------------  
void DumpActs()        //Dump Acts, Print without names and length
{ for(Act ='1'; Act<='8'; Act++) 
  { setEEPROMindexes(Act);
    Serial.println();
    Ccmnd =EEPROM.read(EEPROMindex++);
    // -1 (=255) is uninitialised EEPROM value
    while(Ccmnd !='.' && Ccmnd !=-1) { Serial.print(Ccmnd); Ccmnd =EEPROM.read(EEPROMindex++); }
  }
  Serial.println();
}		
//----------------------------  
void loadAct()
{ redLEDon();  
  getAct();
  if (Ccmnd!='.')
  { setEEPROMindexes(Act);  
    while(true) 
    { while(!Serial.available()) {}  Ccmnd =Serial.read();  //wait for Serial
      if(Ccmnd=='.' || Ccmnd==Esc) { break; }
      EEPROM.write(EEPROMindex,Ccmnd);  EEPROMindex++;
      if (EEPROMindex>=ActEnd) { badkey();  break; }     //null terminated string   
    }
    EEPROM.write(EEPROMindex,'.');
  }
}
//----------------------------  
void copyAct()
{ getAct();
  if (Ccmnd!='.')
  { setEEPROMindexes(Act);
    int fromEEPROMindex =EEPROMindex;  
    int fromActEnd =ActEnd;
    getAct();
    if (Ccmnd!='.')
    { setEEPROMindexes(Act);
      for(byte i =0; i<=fromActEnd -fromEEPROMindex; i++)
        { EEPROM.write(EEPROMindex +i,EEPROM.read(fromEEPROMindex +i)); }
    } 
  }	
}
//----------------------------
char PlayAct() 
{ char _Ccmnd =EEPROM.read(EEPROMindex++);
  if(_Ccmnd==255 || _Ccmnd==-1) _Ccmnd ='.';     //uninitialised EEPROM value, don't play it, change to '.'
  return _Ccmnd;
}  
//----------------------------
void PrintAllActs()
{ for(Act ='1'; Act<='8'; Act++) { printAct(); }  Serial.println(); 
  Serial.print("pace=");     Serial.println(paceby);
  Serial.print("roll=");     Serial.println(rollby);
  Serial.print("turn=");     Serial.println(turnby);
  Serial.print("rollspeed=");     Serial.println(rollspeed);
  Serial.print("pacespeed=");     Serial.println(pacespeed);
  Serial.print("rollspeedmax=");  Serial.println(rollspeedmax);
  Serial.print("pacespeedmax=");  Serial.println(pacespeedmax);
}
//----------------------------
void printAct()
{ setEEPROMindexes(Act);
  Serial.println();    
  Serial.print("Act");
  Serial.print(Act);
  Serial.print(" ");
  Ccmnd =EEPROM.read(EEPROMindex++);
  // -1 (=255) is uninitialised EEPROM value
  while(Ccmnd !='.' && Ccmnd !=-1) { Serial.print(Ccmnd); moves++; Ccmnd =EEPROM.read(EEPROMindex++); }
  EEPROMindex -=1;        //step back to end of record just in case playing
  Serial.print(". - ");
  Serial.print(moves);    //there are moves which take more than 1 character  
  Serial.print(" bytes"); //so the space taken in EEPROM is really bytes
  moves =0;	
}
//----------------------------  
void getAct()
{ Ccmnd =0;
  do
  { if(Serial.available()) 
    { Ccmnd =Serial.read();
      switch (Ccmnd) 
      { case Esc:   Ccmnd ='.';     //[Esc] key, fall through to '.'
        case '.':  Serial.print(">");  break;     // quit, print ready prompt
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':  Act =Ccmnd;  break;
        default: badkey(); Serial.print(" enter Act or '.'"); Ccmnd =0;	
      }  //end case
    } //end if Serial
  } while(Ccmnd==0);
  Serial.print(Ccmnd);
}    
//----------------------------
void setEEPROMindexes(char Act)     // set EEPROM pointers
{ actIndex =Act -'1';               // ASCII to numeric,  Act 1 == actIndex 0
  EEPROMindex =256 +(actIndex*32);  
  ActEnd =EEPROMindex +31;
}
//----------------------------
void badkey()     // indicate invalid key
{ digitalWrite(RwhiskerLEDpin_, LOW);// whisker LED ON
  delay(100);
  digitalWrite(RwhiskerLEDpin_, HIGH);// whisker LED OFF    
  digitalWrite(LwhiskerLEDpin_, LOW);// whisker LED ON
  delay(100);
  digitalWrite(LwhiskerLEDpin_, HIGH);// whisker LED OFF  
  whoa();  
}  
//----------------------------
void printHelp()
{ Serial.println();
  for (int i = 0; i < (sizeof(help_table)/sizeof(int)); i++) 
  //sizeof gives bytes so divide by sizeof(int) to get number of elements
  {
    // see http://arduino.cc/en/Reference/PROGMEM
    strcpy_P(helpbuffer, (char*)pgm_read_word(&(help_table[i]))); // Necessary casts and dereferencing
    Serial.println( helpbuffer );
  }  
}
//----------------------------
void USreact()     // read Ultrasonic sensor and react to objectRange using avoidUObjects() behaviour rules
{ objectRange =dist_HC_SR04();
  Serial.println();
  Serial.print("Ultrasonic distance =");
  Serial.println(objectRange);
  avoidUObjects();
}
//----------------------------
void WhiskerReact()     // read Whisker sensors and avoid obstacles (if any) using avoidObstacles() behaviour rules
{ readWhiskers(); 
  queryObstacles();
  avoidObstacles();
}
//----------------------------
void BeardReact()     // read Beard sensors and avoid holes (if any) using avoidHoles() behaviour rules
{ readBeard();
  queryEdge();
  avoidHoles(); 
}
//----------------------------
void beAlive()         // the loop() from B_PM22_BeAlive
{ while(true)
  { switch (random(9))
    { case 0: WanderSteps(random(10)); break;
      case 1: rock(random(3)); break;
      case 2: shuffle(random(3)); break;
      case 3: whoa(); break;
      case 4: whee(); break;
      case 5: rollspeed =random(1,4); break;
      case 6: pacespeed =random(1,6); break;
      case 7: RightStep(random(6)); break;
      case 8: LeftStep(random(6)); break;
    } // end switch
    //check for Quit
    if(Serial.available()) { Ccmnd =Serial.read(); if(Ccmnd=='.' || Ccmnd==Esc) { Serial.print(">");  break; } }
  }	// end while
}
//----------------------------
void bip()            // make a bip sound
{ beep(voicePin,1500,50); }
//---------------------------- 
void redLEDon()
{ digitalWrite(redLEDpin,HIGH); }  
//----------------------------
void redLEDoff()
{ digitalWrite(redLEDpin,LOW); }  
//----------------------------
void whiskerLEDsOff()
{ digitalWrite(RwhiskerLEDpin_, HIGH);                             // whisker LED OFF
  digitalWrite(LwhiskerLEDpin_, HIGH);                             // whisker LED OFF
}  
//----------------------------  
void whiskerLEDsDim()
{ analogWrite(RwhiskerLEDpin_,254);   //Right whiskerLED, LOW=on so 255 is off
  analogWrite(LwhiskerLEDpin_,254);   //Left whiskerLED, LOW=on so 255 is off
}
//===========================================================























