// Bambino
// TAB FILE > hardware20.ino

//     HARDWARE - ServoPulse(byte Spin, int Spulse), 
//                beep(byte beeppin,int beepfreqHz,long beeptime)

//== HARDWARE ===============================================
void ServoPulse(byte Spin, int Spulse)
// Servos are controlled by a pulse of between 1000 and 2000 micro-seconds
// giving a nominal travel of 100 degrees. The pulse is repeated about 
// every 20 milliseconds (the repeat interval is not critical). 
// Hence mid travel of the servo is given by a 1500 micro-seconds pulse
// and a 10 micro-seconds pulse difference results in one degree nominal travel.
// Servos can have about 180 degree travel depending on the servo type.
// If 90 degrees is given by a 1500 micro-second pulse 
// then zero degrees is 1500-(90*10) =600 micro-seconds
// so a position of X degrees is given by a pulse of 600+(X*10) micro-seconds.
// 
{
  if (f_walking) { digitalWrite(Spin,HIGH); }
  delayMicroseconds(Spulse *10 +600);   // *10+600 to change to micro-seconds
  digitalWrite(Spin,LOW);
}
//----------------------------------------------------------- 
void beep(byte beeppin,int beepfreqHz,long beeptime) //beeptime in millisecs 
{ int periodus =1000000 /beepfreqHz;
  long loops =(beeptime *500)/periodus;       //if beeptime is not long the sums fail
  for (int x=0;x<loops;x++) {
    digitalWrite(beeppin,HIGH);
    delayMicroseconds(periodus/2);
    digitalWrite(beeppin,LOW);
    delayMicroseconds(periodus/2);
    }
}
//===========================================================

