// Bambino
// TAB FILE > skills36.ino

//     SKILLS - turnLight(), turnDark(), turnToLight(), turnToDark()
//     META MOVEMENT - turnAway(), turnMemory(), turnOther() 

//== NEW ====================================================
/*
turnLight(), turnDark(), turnAtLight(), turnAtDark()
*/
//== CHANGED ================================================
/*
*/
//===========================================================
//== SKILLS depending on Light sensors ======================
//LeftRightLightTurnThreshold is the percentage hysteresis
//readLight()  reads whisker light sensor levels into LeyeLight, ReyeLight
//----------------------------
void turnLight()    //turn towards Light 
{ f_AtLight =false ;  readLight() ;
  if ( LeyeLight < 512 || ReyeLight < 512 )         // dim light - Weber difference
    { //Serial.print("dim");
      if ( LeyeLight > ((ReyeLight *LeftRightLightTurnThreshold /100) +ReyeLight )) {Serial.print("L"); turnLeft()  ;}
      else 
      { if ( ReyeLight > ((LeyeLight *LeftRightLightTurnThreshold /100) +LeyeLight )) {Serial.print("R"); turnRight() ;}
        else
        { Serial.print("-"); f_AtLight =true ;
        }
      }  
    }
    else                                            // bright light - headroom Weber difference
    { //Serial.print("bright");
      if ( LeyeLight > (((1023 -ReyeLight) *LeftRightLightTurnThreshold/100) +ReyeLight) ) {Serial.print("L"); turnLeft()  ;}
      else
      { if ( ReyeLight > (((1023 -LeyeLight) *LeftRightLightTurnThreshold/100) +LeyeLight) ) {Serial.print("R"); turnRight() ;}
        else
        { Serial.print("-"); f_AtLight =true ;
        }
      }  
    }  
}
//----------------------------
void turnDark()     //turn towards Dark
{ f_AtDark =false ;  readLight() ;
  if ( LeyeLight < 512 || ReyeLight < 512 )         // dim light - Weber difference
    { //Serial.print("dim");
      if ( ((LeyeLight *LeftRightLightTurnThreshold /100) +LeyeLight) < ReyeLight ) {Serial.print("L"); turnLeft()  ;}
      else
      { if ( ((ReyeLight *LeftRightLightTurnThreshold /100) +ReyeLight) < LeyeLight ) {Serial.print("R"); turnRight() ;}
        else
        { Serial.print("-"); f_AtDark =true ;
        }
      }  
    }
    else                                            // bright light - headroom Weber difference
    { //Serial.print("bright");
      if ( (((1023 -LeyeLight) *LeftRightLightTurnThreshold/100) +LeyeLight) < ReyeLight ) {Serial.print("L"); turnLeft()  ;}
      else
      { if ( (((1023 -ReyeLight) *LeftRightLightTurnThreshold/100) +ReyeLight) < LeyeLight ) {Serial.print("R"); turnRight() ;}
        else
        { Serial.print("-"); f_AtDark =true ;
        }
      }  
    }
}
//----------------------------
void turnAtLight()  //turn until facing Light
{ do { turnLight() ;} while ( !f_AtLight ) ;
}
//----------------------------
void turnAtDark()   //turn until facing Dark
{ do { turnDark() ;} while ( !f_AtDark ) ;
}
//===========================================================
//== META MOVEMENT depending on memory ======================
void turnMemory()  // turn the same way as last time
{ if (f_TurnedRight) {turnRight();}  else {turnLeft();} }
//----------------------------
void turnOther()   // turn the opposite way from last time
{ if (f_TurnedRight) {turnLeft();}  else {turnRight();} }

//===========================================================
//== META MOVEMENT depending on state =======================
void turnAway()    // turn away from the leading foot, so if the right foot is in front then turn left
{ if (paceat < paceC)          // ie right foot forward    
  {turnLeft();}  else {turnRight();}
}
//===========================================================








