// Bambino
// TAB FILE > behaviourPM20.ino

//     BEHAVIOUR MODIFIERS - speeddown(), speedup()
//     BEHAVIOUR RULES - avoidUObjects(), avoidObstacles(), avoidHoles()

//== BEHAVIOUR MODIFIERS ====================================
void speeddown()          // reduce by half rollspeed and pacespeed with a minimum of 1
{ rollspeed =max(1, rollspeed/2); pacespeed =max(1, pacespeed/2); }
//----------------------------
void speedup()            // increase by 1 rollspeed and pacespeed upto rollspeedmax and pacespeedmax
{ rollspeed =min(rollspeedmax, rollspeed++); pacespeed =min(pacespeedmax, pacespeed++); }    
//== BEHAVIOUR RULES ========================================
void avoidUObjects()
{ // check objectRange from Ultrasonic module HC-SR04
  if(objectRange <10) { beep(voicePin,1500,200);  speeddown(); backward(); }
  if(objectRange <15) { beep(voicePin,800,200);   speeddown(); turnAway(); turnMemory(); turnMemory(); }
  if(objectRange <20) { beep(voicePin,400,200);   turnMemory(); }
}
//----------------------------
void avoidObstacles()
{  if (f_obstacleRight && f_obstacleLeft) 
  { speeddown();
    digitalWrite(RwhiskerLEDpin_, LOW);        // whisker LED ON - indicate an obstacle
    digitalWrite(LwhiskerLEDpin_, LOW);        // whisker LED ON - indicate an obstacle
    backward(); turnOther(); turnMemory(); turnMemory(); turnMemory(); turnMemory();
	digitalWrite(RwhiskerLEDpin_, HIGH);       // whisker LED Off
	digitalWrite(LwhiskerLEDpin_, HIGH);       // whisker LED Off
  }
  else
  {
    if (f_obstacleRight) 
    { speeddown();
	  digitalWrite(RwhiskerLEDpin_, LOW);        // whisker LED ON - indicate an obstacle
      backward(); turnLeft(); turnLeft(); turnLeft();  turnLeft(); 
	  digitalWrite(RwhiskerLEDpin_, HIGH);       // whisker LED Off
    }
	else
	{
      if (f_obstacleLeft) 
      { speeddown();
	    digitalWrite(LwhiskerLEDpin_, LOW);        // whisker LED ON - indicate an obstacle
        backward(); turnRight(); turnRight(); turnRight();  turnRight();
	    digitalWrite(LwhiskerLEDpin_, HIGH);       // whisker LED Off
      }
	}
  }	
}
//----------------------------
void avoidHoles()
{  if (f_holeRight && f_holeLeft) 
  { speeddown(); 
    digitalWrite(RbeardLEDpin_, LOW);        // beard LED ON - indicate a hole
    digitalWrite(LbeardLEDpin_, LOW);        // beard LED ON - indicate a hole
    backward(); turnOther(); turnMemory(); turnMemory(); turnMemory(); turnMemory();
	digitalWrite(RbeardLEDpin_, HIGH);       // beard LED Off
	digitalWrite(LbeardLEDpin_, HIGH);       // beard LED Off
  }
  else
  {
    if (f_holeRight) 
    { speeddown(); 
	  digitalWrite(RbeardLEDpin_, LOW);        // beard LED ON - indicate a hole
      backward(); turnLeft(); turnLeft(); turnLeft();  turnLeft(); 
	  digitalWrite(RbeardLEDpin_, HIGH);       // beard LED Off
    }
	else
	{
      if (f_holeLeft) 
      { speeddown(); 
	    digitalWrite(LbeardLEDpin_, LOW);        // beard LED ON - indicate a hole
        backward(); turnRight(); turnRight(); turnRight();  turnRight();
	    digitalWrite(LbeardLEDpin_, HIGH);       // beard LED Off
      }
	}
  }	
}
//===========================================================









